mod parser;

use common::{Day, Part};

pub fn run_day_and_part(day: Day, part: Part, inp: &str) -> usize {
    match (day, part) {
        (Day::Two, Part::One) => parser::part_01::parse(inp).iter().sum(),
        (Day::Two, Part::Two) => parser::part_02::parse(inp).iter().sum(),
        (_, _) => unimplemented!(),
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn part_01_example_score_is_correct() {
        assert_eq!(15, run_day_and_part(Day::Two, Part::One, "A Y\nB X\nC Z"))
    }

    #[test]
    fn part_02_example_score_is_correct() {
        assert_eq!(12, run_day_and_part(Day::Two, Part::Two, "A Y\nB X\nC Z"))
    }
}
